package ANALYZE;
#
#This file is part of NNIPF(Version 0.06-release):SPAM mail filtering software
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

#################
sub IsPrivate{
  my ($OIP) = @_;
  $res = 0;
  if (($OIP =~ /^10\.[0-9]+\.[0-9]+\.[0-9]+/)||
      ($OIP =~ /^172\.(16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31)\.[0-9]+\.[0-9]+/)||
      ($OIP =~ /^192\.168\.[0-9]+\.[0-9]+/ )) {$res=1;}
  return $res;
}


################
sub IpDictMatch{
  my ($query,$Dict, $Flg) = @_;
  my $match1, $match2, $ret;
  if ($Dict eq $main::BADIP) {
    $match1 = DictMatch($query,$Dict,$Flg);
    if (-d $main::MBADIP) {
	$match2 = DictMatch($query,$main::MBADIP,0);
        $ret=($match1<$match2 ? $match1:$match2);
    }else{$ret=$match1;}
  }elsif ($Dict eq $main::GOODIP){
    $match1 = DictMatch($query,$Dict,$Flg);
    if (-d $main::MGOODIP) {
       $match2 = DictMatch($query,$main::MGOODIP,0);
       $ret=($match1<$match2 ? $match1:$match2);
    }else{$ret=$match1;}
  }
  return $ret;
}
sub DictMatch{
  ($query,$Dict, $Flg) = @_;
  my @qaddr=split(/\./,$query);
  my $dir=$Dict;
  my $fc=0;
  my $count, $counter;
  my $flag;
  for ($i=0, $match=0, $flag=1; $i<4; $i++){
    if (-e ($filename=sprintf("%s/%s",$dir,$qaddr[$i])) ){
      $fc=0;
      if ($Flg){
        if (-e ($counter=sprintf("%s/Count",$filename))){
          open INc, $counter or die "$counter:$!";
          while(<INc>) {$count=$_;}
          close(INc);
          unlink($counter);
          $count+=1;
        }else{$count=1;}
        open OUTc, ">$counter" or die "$counter:$!";
        print(OUTc $count);
        close(OUTc);
      }
    }elsif ($flag) {
      $flag=0;
      opendir DH, $dir or die "$dir:$!";
      $fc=256;
      while (my $file = readdir DH) {  
        next if $file =~ /^\.{1,2}$/;
        if (abs($file-$qaddr[$i]) < $fc) {
          $fc=abs($file-$qaddr[$i]);
        }
      }
    }else{$fc=256;}
    $match=$match*256+$fc;
    $dir=$filename;
  }
  return $match;
}

#####################
sub IpDictAdd{
  ($query,$Dict) = @_;
  my @qaddr=split(/\./,$query);
  my $filename=$Dict;
  
  for ($i=0; $i<4; $i++){
    $filename=sprintf("%s/%s",$filename,$qaddr[$i]);
    if (!-e $filename ) {
      mkdir($filename);
    }
    
    if (-e ($counter=sprintf("%s/Count",$filename))){
      open INc, $counter or die "$counter:$!";
      while(<INc>) {$count=$_;}
      close(INc);
    }else{$count=1;}
    open OUTc, ">$counter" or die "$counter:$!";
    print(OUTc $count);
    close(OUTc);
  }
}

####################
sub IpDictRemove{
  ($query,$Dict) = @_;
  $query =~ s/\./\//g;
  $dir=$Dict . "/" . $query;
  
  $prevfc=0;
  $prevdir=$dir;
  for ($i=0; $i<4; $i++){
    opendir DH, $dir or die "$dir:$!";
    $fc=0;
    while (my $file = readdir DH) {  
      next if $file =~ /^\.{1,2}$/;
      $fc++;
      $file = $dir . "/" . $file; 
      if ( -f $file ) {unlink($file);$fc--;}
      elsif (($file eq $prevdir)&&(-d $file)&&($prevfc eq 0))
        {rmdir($file);$fc--;}
    }
    $prevdir = $dir;
    $prevfc = $fc;
    $dir=substr($dir,0,rindex($dir,"/"));
    closedir DH;
  }
}

###########################
sub IpDictAddExclusive{
  my ($OIP, $DICT1, $DICT2) = @_;
  IpDictAdd($OIP,$DICT1);
  if (IpDictMatch($OIP,$DICT2,0) eq 0) {
    IpDictRemove($OIP,$DICT2);
  }
}
#######################
sub analyze{
  my ($str,$BADIP,$GOODIP) = @_;
  
  my $OIP = HEADER::officialIP($str);
### Check IP address
  my $Bip = IpDictMatch($OIP,$BADIP,0);
  my $Gip = IpDictMatch($OIP,$GOODIP,0);
  return Bratio($Gip,$Bip);
}

######################
sub Bratio{
  my ($Dg, $Db) = @_;
  if ($Dg+$Db eq 0) {$eps=1;}else{$eps=0;}
  return $Dg/($Dg+$Db+$eps);
}
######################
sub distinctiveness{
  my ($OIP, $Flg) = @_;
  if (IsPrivate($OIP)) {return 0;}
  else{
    ### Check IP address
    my $Bip = IpDictMatch($OIP,$main::BADIP,$Flg);
    my $Gip = IpDictMatch($OIP,$main::GOODIP,$Flg);
    return Bratio($Gip,$Bip);
  }
}
1;
