package HEADER;
#
#This file is part of NNIPF(Version 0.06-release):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#
##################### (FileHandle,Buffer) => hash
#             members = 'lcount', 'Frm', 'OIP', 'Dis', 'from', 'subject'
sub HeaderAnalysis{
  (*INt, *Buf, $Flg) = @_;
  my $lcount=0;
  my $line="";
  my $res;
  my $rf;
  my  $distinc;
  # Init
  my $hflag=1;
  my $Rflag = 0;
  my $Maxdistinc=0;
  my $OIP;
  
  while (($hflag)&& ($line = <INt>)){
    $Buf[$lcount++] = $line;
    $line =~ s/\n//;
    # When Empty line is read
    if (length($line) eq 0) {$hflag = 0; }
    # Make each Field into a single line
    if ($line =~ /^([A-z0-9\-]*): /) {
      if ($Rflag eq 1) {
        if ($Rline =~ /^Received: (.*)$/) {
          
          $rf=ReceivedFrom($1);
          if (($rf->{'by'})&&(Checkb($rf->{'by'}))) {
            if ($rf->{'rfrom'}) {
              $OIP=officialIP($rf->{'rfrom'});
              if (($OIP)&&(($distinc=ANALYZE::distinctiveness($OIP,$Flg))>=$Maxdistinc)){
                $res->{'Frm'}=$rf->{'rfrom'};
                $res->{'OIP'}=$OIP;
                $res->{'Dis'}=$distinc;
		$res->{'by'}=$rf->{'by'};
                $Maxdistinc=$distinc;
              }
            }
          }
        }else{
          if ($Rline =~ /^From: /) {$res->{'from'} = substr($Rline,6);}
          elsif ($Rline =~ /^Subject: /) {$res->{'subject'} = substr($Rline,9);}
        }
      } else {$Rflag=1;}
      $Rline=$line;
    }else{
      if ($Rflag) {
        $line =~ s/^\s*//g;
        $Rline = $Rline . $line;
      }
    }
  }
  ####### Post Processing
  if (($res->{'Frm'} eq "")&&($rf->{'rfrom'})) {
    $res->{'Frm'}=$rf->{'rfrom'};
    $OIP=officialIP($res->{'Frm'});
    $res->{'OIP'}=$OIP;
    $res->{'Dis'}=ANALYZE::distinctiveness($OIP,$Flg);
  }elsif ($res->{'Frm'} eq "") {
    $res->{'Frm'}='';$res->{'OIP'}='';$res->{'Dis'}=0;
  }
  chomp($res->{'Frm'});
  $res->{'lcount'} = $lcount;
  return $res;
}

############# string => from string and by string
# hash members = 'rfrom', 'by'
#
sub ReceivedFrom{
  ($l)=@_;
  my $res;
  if ($l =~ /^from (.*)by (.*)for (.*);(.*)$/ ){
    $res->{'rfrom'} = $1;
    $res->{'by'} = substr($2,0,index($2," with"));
    if ($res->{'by'} =~ /([A-z0-9\.\-_]*) /) {$res->{'by'} = $1;}
    $res->{'rfrom'} =~ s/ *$//;
  }elsif ($l =~ /^from (.*)by (.*);(.*)$/){
    $res->{'rfrom'} = $1;
    $res->{'by'} = substr($2,0,index($2," with"));
    if ($res->{'by'} =~ /([A-z0-9\.\-_]*) /) {
      $res->{'by'} = $1;
    }
    $res->{'rfrom'} =~ s/ *$//;
  }
  return $res;
}
######################## from string returned by ReceivedFrom() to official IP
sub officialIP{
  my ($str)=@_;
  my $OIP="";
  my @h=split(/ /,$str);
  if ($str =~ /.*\[([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)\].*/) {
    $OIP =$1;
  }
  if  ($h[3] =~ /[^0-9]*([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)[^0-9]*/) {
    $OIP = $1;
  }
  return $OIP;
}
############# Reading Boundary File (side effect to %hash)
sub bRead{
  ($Dict) = @_;
  @hash = ();
  my $i=0;
  open INb,$Dict or die "$Dict:$!";
  while(<INb>){ $_ =~ s/\n//; $_ =~ s/\r//; $hash[$i++]="$_"; }
  close(INb);
}

############# Check whether $query matches MTAOB or not? true or false 
sub Checkb {
  ($query) = @_;
  my $i;
  foreach $i (@hash) {
    if ( $query =~ /^$i$/){
      return 1;
    }
  }
  return 0;
}
############
sub DictMatch{
  ($query,$Dict) = @_;
  my $flag=0;
  open INdict, $Dict or die "$Dict:$!";
  while(($x = <INdict>)&&($frag eq 0)) {$x =~ s/\n//;
    if ($x eq $query) {$frag=1;}
  }
  close(INdict);
  return $frag;
}
############ Read string just after "Received: from"
sub rvf{
  my ($fn) = @_;
  my $header;
  my @Buf;
  open INtmp, $fn or die "$fn: $!";
  $header=HeaderAnalysis(*INtmp,*Buf,0);
  close(INtmp);
  return $header->{'Frm'};
}
1;
